Skip to main content
`Ctrl`+`K`

# MatQRFactor

Performs in-place QR factorization of matrix.

## Synopsis

    #include "petscmat.h"
    PetscErrorCode MatQRFactor(Mat mat, IS col, const MatFactorInfo *info)

Collective

## Input Parameters

- mat - the matrix

- col - column permutation

- info - options for factorization, includes

              fill - expected fill as ratio of original fill.
              dtcol - pivot tolerance (0 no pivot, 1 full column pivoting)
                       Run with the option -info to determine an optimal value to use

## Notes

Most users should employ the `KSP` interface for linear solvers instead of working directly with matrix algebra routines such as this. See, e.g., `KSPCreate()`.

This changes the state of the matrix to a factored matrix; it cannot be used for example with `MatSetValues()` unless one first calls `MatSetUnfactored()`.

## Fortran Note

A valid (non-null) `info` argument must be provided

## See Also

Matrices, `Mat`, Matrix Factorization, `MatFactorInfo`, `MatGetFactor()`, `MatQRFactorSymbolic()`, `MatQRFactorNumeric()`, `MatLUFactor()`, `MatSetUnfactored()`

## Level

developer

## Location

src/mat/interface/matrix.c

## Implementations

MatQRFactor_SeqDense() in src/mat/impls/dense/seq/dense.c

Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages